package dev.shadowsoffire.apotheosis.potion;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonObject;
import dev.shadowsoffire.apotheosis.ench.table.EnchantingRecipe;
import dev.shadowsoffire.apotheosis.ench.table.EnchantingStatRegistry;
import dev.shadowsoffire.apotheosis.potion.PotionEnchantingRecipe;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.crafting.Recipe;
import net.minecraft.world.item.crafting.RecipeSerializer;
import org.apache.commons.lang3.tuple.Pair;

public class Serializer implements RecipeSerializer<PotionEnchantingRecipe> {
  protected static final Gson GSON = (new GsonBuilder()).create();
  
  public PotionEnchantingRecipe fromJson(ResourceLocation id, JsonObject obj) {
    Pair<EnchantingStatRegistry.Stats, EnchantingStatRegistry.Stats> requirements = PotionEnchantingRecipe.access$000(id, obj);
    return new PotionEnchantingRecipe((EnchantingStatRegistry.Stats)requirements.getLeft(), (EnchantingStatRegistry.Stats)requirements.getRight());
  }
  
  public PotionEnchantingRecipe fromNetwork(ResourceLocation id, FriendlyByteBuf buf) {
    EnchantingStatRegistry.Stats stats = EnchantingStatRegistry.Stats.read(buf);
    EnchantingStatRegistry.Stats maxStats = buf.readBoolean() ? EnchantingStatRegistry.Stats.read(buf) : EnchantingRecipe.NO_MAX;
    return new PotionEnchantingRecipe(stats, maxStats);
  }
  
  public void toNetwork(FriendlyByteBuf buf, PotionEnchantingRecipe recipe) {
    PotionEnchantingRecipe.access$100(recipe).write(buf);
    buf.writeBoolean((PotionEnchantingRecipe.access$200(recipe) != EnchantingRecipe.NO_MAX));
    if (PotionEnchantingRecipe.access$300(recipe) != EnchantingRecipe.NO_MAX)
      PotionEnchantingRecipe.access$400(recipe).write(buf); 
  }
}
